"""Base class for latflow"""
import tensorflow as tf
import numpy as np


class _Lattice():
    @property
    def weights(self):
        return tf.reshape(tf.constant(self._weights, dtype=1),
                          (self.dim + 1) * [1] + [self.nneighbors])

    @property
    def lveloc(self):
        return tf.reshape(tf.constant(self._lveloc, dtype=1),
                          self.dim * [1] + [self.nneighbors, 3])

    @property
    def bounce(self):
        return tf.reshape(tf.constant(np.array(self._bounce), dtype=1),
                          self.dim * [1] + [self.nneighbors, self.nneighbors])

    @property
    def stream(self):
        tmp = np.zeros([3] * self.dim + [self.nneighbors, self.nneighbors])
        for pos in self._stream:
            tmp[pos] = 1.0
        return tf.constant(tmp, dtype=1)


class _Lattice2D(_Lattice):
    dim = 2


class _Lattice3D(_Lattice):
    dim = 3


class D2Q9(_Lattice2D):
    nneighbors = 9
    _weights = (4./9., 1./9., 1./9., 1./9., 1./9., 1./36., 1./36., 1./36., 1./36.)
    _lveloc = ((0,0,0), (1,0,0), (0,1,0), (-1,0,0), (0,-1,0), (1,1,0), (-1,1,0), (-1,-1,0), (1,-1,0))
    _bounce = (( 1.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0),
               ( 0.0,  0.0,  0.0,  1.0,  0.0,  0.0,  0.0,  0.0,  0.0),
               ( 0.0,  0.0,  0.0,  0.0,  1.0,  0.0,  0.0,  0.0,  0.0),
               ( 0.0,  1.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0),
               ( 0.0,  0.0,  1.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0),
               ( 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  1.0,  0.0),
               ( 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  1.0),
               ( 0.0,  0.0,  0.0,  0.0,  0.0,  1.0,  0.0,  0.0,  0.0),
               ( 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  1.0,  0.0,  0.0))
    _stream = (
            (1, 1, 0, 0),
            (1, 0, 1, 1),
            (0, 1, 2, 2),
            (1, 2, 3, 3),
            (2, 1, 4, 4),
            (0, 0, 5, 5),
            (0, 2, 6, 6),
            (2, 2, 7, 7),
            (2, 0, 8, 8))


class D3Q19(_Lattice3D):
    nneighbors = 19
    _weights = ( 1./3., 1./18., 1./18., 1./18., 1./18., 1./18., 1./18.,
                 1./36., 1./36., 1./36., 1./36., 1./36., 1./36., 1./36.,
                 1./36., 1./36., 1./36., 1./36., 1./36.)
    _lveloc = (( 0, 0, 0), ( 1, 0, 0), (-1, 0, 0), ( 0, 1, 0), ( 0,-1, 0),
               ( 0, 0, 1), ( 0, 0,-1), ( 1, 1, 0), (-1,-1, 0), ( 1,-1, 0),
               (-1, 1, 0), ( 1, 0, 1), (-1, 0,-1), ( 1, 0,-1), (-1, 0, 1),
               ( 0, 1, 1), ( 0,-1,-1), ( 0, 1,-1), ( 0,-1, 1))
    _bounce = (( 1.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0),
               ( 0.0,  0.0,  1.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0),
               ( 0.0,  1.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0),
               ( 0.0,  0.0,  0.0,  0.0,  1.0,  0.0,  0.0,  0.0,  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0),
               ( 0.0,  0.0,  0.0,  1.0,  0.0,  0.0,  0.0,  0.0,  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0),
               ( 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  1.0,  0.0,  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0),
               ( 0.0,  0.0,  0.0,  0.0,  0.0,  1.0,  0.0,  0.0,  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0),
               ( 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0),
               ( 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  1.0,  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0),
               ( 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0),
               ( 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0),
               ( 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0),
               ( 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0),
               ( 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0),
               ( 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0),
               ( 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0),
               ( 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0),
               ( 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0),
               ( 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0))
    _stream = (
            (1,1,1, 0, 0),
            (1,1,0, 1, 1),
            (1,1,2, 2, 2),
            (0,0,1, 3, 3),
            (1,2,1, 4, 4),
            (0,1,1, 5, 5),
            (2,1,1, 6, 6),
            (1,0,0, 7, 7),
            (1,2,2, 8, 8),
            (1,2,0, 9, 9),
            (1,0,2,10,10),
            (0,1,0,11,11),
            (2,1,2,12,12),
            (2,1,0,13,13),
            (0,1,2,14,14),
            (0,0,1,15,15),
            (2,2,1,16,16),
            (2,0,1,17,17),
            (0,2,1,18,18))
